/*******************************************************************
 *
 *    DESCRIPTION:	ata_dir.h
 *
 *    AUTHOR:		Mark de Jong
 *
 *    HISTORY:    
 *
 *******************************************************************/

#ifndef ATA_DIRH
#define ATA_DIRH

typedef struct
{
	unsigned char Name[13];
	unsigned char Lname[260];
	unsigned char Attr;
	unsigned long Time;
	unsigned long Date;
	unsigned long Filesize;
	unsigned long FirstCluster;
}FILE_ENTRY;

typedef _packed struct
{
	unsigned char Name[11];
	unsigned char Attr;
	unsigned char NTRes;
	unsigned char CrtTimeTenth;
	unsigned int  CrtTime;
	unsigned int  CrtDate;
	unsigned int  LstAccDate;
	unsigned int  FstClusHI;
	unsigned int  WrtTime;
	unsigned int  WrtDate;
	unsigned int  FstClusLO;
	unsigned long FileSize;
}DIR_ENTRY;

typedef _packed struct
{
	unsigned char sequence;
	unsigned char lname1[10];
	unsigned char attr;
	unsigned char type;
	unsigned char chksum;
	unsigned char lname2[12];
	unsigned int  first;
	unsigned char lname3[4];
}LFN_ENTRY;

// DIR_ENTRY.Attr
#define ATTR_READ_ONLY				0x01
#define ATTR_HIDDEN					0x02
#define ATTR_SYSTEM					0x04
#define ATTR_VOLUME_ID				0x08
#define ATTR_DIRECTORY				0x10
#define ATTR_ARCHIVE				0x20
#define ATTR_LONG_NAME				0x0F //ATTR_READ_ONLY | ATTR_HIDDEN | ATTR_SYSTEM | ATTR_VOLUME_ID


#endif // ATA_DIRH