/*******************************************************************
 *
 *    DESCRIPTION:	fat.h
 *
 *    AUTHOR:		Mark de Jong
 *
 *    HISTORY:    
 *
 *******************************************************************/

#ifndef FAT_H
#define FAT_H

typedef _packed struct
{
	_packed unsigned char BS_DrvNum;
	_packed unsigned char BS_Reserved1;
	_packed unsigned char BS_BootSig;
	_packed unsigned long BS_VolID;
	_packed unsigned char BS_VolLabel[11];
	_packed unsigned char BS_FilSysType[8];
}FAT16;

typedef _packed struct
{
	_packed unsigned long BPB_FATSz32;
	_packed unsigned int  BPB_ExtFlags;
	_packed unsigned int  BPB_FSVer;
	_packed unsigned long BPB_RootClus;
	_packed unsigned int  BPB_FS_Info;
	_packed unsigned int  BPB_BkBootSec;
	_packed unsigned char BPB_Reserved[12];
	_packed unsigned char BS_DrvNum;
	_packed unsigned char BS_Reserved1;
	_packed unsigned char BS_BootSig;
	_packed unsigned long BS_VolID;
	_packed unsigned char BS_VolLabel[11];
	_packed unsigned char BS_FilSysType[8];
}FAT32;

typedef _packed struct
{
	_packed unsigned char BS_jmpBoot[3];
	_packed unsigned char BS_OEMName[8];
	_packed unsigned int  BPB_BytesPerSec;
	_packed unsigned char BPB_Sec_Per_clus;
	_packed unsigned int  BPB_RsvdSecCnt;
	_packed unsigned char BPB_NumFATs;
	_packed unsigned int  BPB_RootEntCnt;
	_packed unsigned int  BPB_TotSec16;
	_packed unsigned char BPB_Media;
	_packed unsigned int  BPB_FATSz16;
	_packed unsigned int  BPB_SecPerTrk;
	_packed unsigned int  BPB_NumHeads;
	_packed unsigned long BPB_HiddSec;
	_packed unsigned long BPB_TotSec32;
	union
	{
		FAT16	  fat16;
		FAT32	  fat32;
	}fat;
}BS_AND_BPB;


typedef _packed struct
{
	_packed unsigned char Name[11];
	_packed unsigned char Attr;
	_packed unsigned char NTRes;
	_packed unsigned char CrtTimeTenth;
	_packed unsigned int  CrtTime;
	_packed unsigned int  CrtDate;
	_packed unsigned int  LstAccDate;
	_packed unsigned int  FstClusHI;
	_packed unsigned int  WrtTime;
	_packed unsigned int  WrtDate;
	_packed unsigned int  FstClusLO;
	_packed unsigned long FileSize;
}DIR_ENTRY;

typedef _packed struct
{
	_packed unsigned char sig;
	_packed unsigned char lname1[10];
	_packed unsigned char attr;
	_packed unsigned char flags;
	_packed unsigned char chksum;
	_packed unsigned char lname2[12];
	_packed unsigned char first;
	_packed unsigned char lname3[4];
}LFN_ENTRY;

// DIR_ENTRY.Attr
#define ATTR_READ_ONLY				0x01
#define ATTR_HIDDEN					0x02
#define ATTR_SYSTEM					0x04
#define ATTR_VOLUME_ID				0x08
#define ATTR_DIRECTORY				0x10
#define ATTR_ARCHIVE				0x20
#define ATTR_LONG_NAME				0x0F //ATTR_READ_ONLY | ATTR_HIDDEN | ATTR_SYSTEM | ATTR_VOLUME_ID


unsigned long FirstSectorOfCluster( volume_info_type volume_info, unsigned long cluster );
unsigned long ThisFATSectorNumber( volume_info_type volume_info, unsigned long cluster );
unsigned long ThisFATEntryOffset( volume_info_type volume_info, unsigned long cluster );
unsigned long ClusterEntryValue( volume_info_type volume_info, unsigned long cluster );

#endif // FAT_H